#include <iostream>
#include <fstream>
#include <utility>
#include <vector>
#include <queue>

using namespace std;

const int mcm = 420;
const int MAXN = 10000;
const int inf = 1e9;

vector<int> adj[MAXN];
int dist[MAXN][mcm];

int main() {
    // N nodes
    // M edges
    // K guards, i-th cycle has length L_i
    int N,M,K;
    cin >> N >> M >> K;
    for(int i = 0; i < M; ++i){ 
        int a,b;
        cin >> a >> b;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    for(int i = 0; i < N; ++i)adj[i].push_back(i);
    for(int i = 0; i < MAXN; ++i){
        for(int j = 0; j < mcm; ++j){
            dist[i][j] = inf;
        }
    }
    for(int i = 0; i < K; ++i){
        int l; cin >> l;
        int n;
        for(int j = 0; j < l; ++j){
            cin >> n; 
            for(int k = j; k < mcm; k+=l)dist[n][k] = -1;
        }
    }


    queue<pair<int,int>> q;
    q.push({0,0});
    dist[0][0] = 0;
    while(!q.empty()){
        auto [n, m] = q.front();
        int d = dist[n][m];
        
        for(auto x: adj[n]){
            if(dist[x][(m + 1)%mcm] == -1)continue; 
            if(d + 1 < dist[x][(m + 1)%mcm]){
                dist[x][(m + 1)%mcm] = d + 1;
                q.push({x, (m + 1)%mcm});
            }
        }
        q.pop();
    }

    int r = inf;
    for(int i = 0; i < mcm; ++i)if(dist[N - 1][i] != -1)r = min(dist[N-1][i], r);
    cout << (r==inf ? -1 : r) << endl; 
        
    return 0;
}