#include <bits/stdc++.h>
using namespace std;

const int MAXN = (int)2e5;
const int MAXVAL = (int)3e4;
const int LG = 18;
inline void Open(const string Name) {
    #ifndef ONLINE_JUDGE
        (void)!freopen((Name + ".in").c_str(), "r", stdin);
        (void)!freopen((Name + ".out").c_str(), "w", stdout);
    #endif
}

int n;
vector<int> g[MAXN + 1], subset[2][MAXVAL + 1];
int val[MAXN + 1], dep[MAXN + 1], dad[MAXN + 1], sz[MAXN + 1], pos[2 * MAXN + 5];
long long sum[MAXN + 1];
int rmq[LG + 1][2 * MAXN + 5], lg[2 * MAXN + 5], ddy[MAXN + 1];
vector<int> order, depth;

void decomp(int i) {
    int x = val[i];
    vector<int> factors;
    for (int d = 2; d * d <= x; d++) {
        if (x % d == 0) {
            factors.push_back(d);
            while (x % d == 0) {
                x /= d;
            }
        }
    }
    if (x > 1) {
        factors.push_back(x);
    }
    int cntSubsets = (1 << (int)factors.size());
    for (int mask = 1; mask < cntSubsets; mask++) {
        int p = 1, cnt = 0;
        for (int bit = 0; bit < (int)factors.size(); bit++) {
            if ((mask & (1 << bit)) > 0) {
                p = p * factors[bit];
                cnt++;
            }
        }
        subset[cnt % 2][p].push_back(i);
    }
}

void dfs(int u, int parrent) {
    decomp(u);
    sum[u] = sum[parrent] + val[u];
    ddy[u] = parrent;
    order.push_back(u);
    depth.push_back(dep[u]);
    if (pos[u] == 0) {
        pos[u] = (int)order.size() - 1;
    }
    for (int &v : g[u]) {
        if (v == parrent) {
            continue;
        }
        dep[v] = 1 + dep[u];
        dfs(v, u);
        order.push_back(u);
        depth.push_back(dep[u]);
    }
}

void precalcLca() {
    int len = (int)order.size();
    for (int i = 2; i <= MAXN; i++) {
        lg[i] = lg[i / 2] + 1;
    }
    for (int i = 1; i <= len; i++) {
        rmq[0][i] = i;
    }
    for (int l = 1; (1 << l) <= len; l++) {
        for (int i = 1; i < len - (1 << l) + 1; i++) {
            int lst = i + (1 << (l - 1));
            if (depth[rmq[l - 1][i]] < depth[rmq[l - 1][lst]]) {
                rmq[l][i] = rmq[l - 1][i];
            } else {
                rmq[l][i] = rmq[l - 1][lst];
            }
        }
    }
    for (int i = 0; i <= n; i++) {
        dad[i] = i;
        sz[i] = 1;
    }
}

int lca(int u, int v) {
    u = pos[u], v = pos[v];
    if (u < v) {
        swap(u, v);
    }
    int len = lg[u - v + 1];
    if (depth[rmq[len][v]] < depth[rmq[len][u - (1 << len) + 1]]) {
        return order[rmq[len][v]];
    } else {
        return order[rmq[len][u - (1 << len) + 1]];
    }
}

int find(int u) {
    if (u == dad[u]) {
        return u;
    }
    return dad[u] = find(dad[u]);
}

void join(int u, int v) {
    if (sz[u] < sz[v]) {
        swap(u, v);
    }
    dad[v] = u;
    sz[u] += sz[v];
}

int main() {
    Open("sumtree");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> n;
    assert(1 <= n && n <= 100000);
    for (int i = 1; i <= n; i++) {
        cin >> val[i];
        assert(2 <= val[i] && val[i] <= 30000);
    }
    for (int i = 0; i < n - 1; i++) {
        int u, v; cin >> u >> v;
        assert(1 <= u && u <= n);
        assert(1 <= v && v <= n);
        g[u].push_back(v);
        g[v].push_back(u);
    }
    order.push_back(0);
    depth.push_back(0);
    dep[1] = 1;
    dfs(1, 0);
    precalcLca();
    long long ans = 0;
    for (int add = 0; add < 2; add++) {
        for (int value = 2; value <= MAXVAL; value++) {
            if ((int)subset[add][value].size() < 2) {
                continue;
            }
            vector<pair<pair<int, int>, int>> nodes;
            for (int i = 1; i < (int)subset[add][value].size(); i++) {
                nodes.push_back(make_pair(make_pair(subset[add][value][i - 1], subset[add][value][i]), lca(subset[add][value][i - 1], subset[add][value][i])));
            }
            sort(nodes.begin(), nodes.end(), [&](const pair<pair<int, int>, int> &a, const pair<pair<int, int>, int> &b) {
                return dep[a.second] > dep[b.second];
            });
            long long subsetSum = 0;
            for (const int &x : subset[add][value]) {
                subsetSum = (long long)subsetSum + (long long)(subset[add][value].size() - 1) * sum[x];
            }
            for (const auto &p : nodes) {
                int u = find(p.first.first), v = find(p.first.second), root = p.second;
                if (u == v) {
                    continue;
                }
                subsetSum = (long long)subsetSum - (long long)2 * sum[root] * (long long)sz[u] * sz[v];
                subsetSum = (long long)subsetSum + (long long)sz[u] * sz[v] * val[root];
                join(u, v);
            }
            if (add == 1) {
                ans = (long long)ans + subsetSum;
            } else {
                ans = (long long)ans - subsetSum;
            }
            for (const int &x : subset[add][value]) {
                dad[x] = x;
                sz[x] = 1;
            }
        }
    }
    cerr << "Solution asnwer = " << ans << "\n";
    cout << ans << "\n";
    return 0;
}
