#include <bits/stdc++.h>

using namespace std;

struct trie_node {
    int mask;
    trie_node *nxt[26];
    trie_node *pi;

    trie_node() {
        this -> mask = 0;
        for(int i = 0; i < 26; i++) {
            this -> nxt[i] = NULL;
        }
        this -> pi = NULL;
    }
};

void insert_trie(trie_node *root, string &W, int index) {
    trie_node *curr = root; 
    for(auto ch : W) {
        if(curr -> nxt[ch - 'a'] == NULL) {
            curr -> nxt[ch - 'a'] = new trie_node;
        }
        curr = curr -> nxt[ch - 'a'];
    }
    curr -> mask |= 1 << index;
}

void compute_pi(trie_node *root) {
    queue <trie_node *> Q;
    for(int i = 0; i < 26; i++) {
        if(root -> nxt[i] != NULL) {
            root -> nxt[i] -> pi = root;
            Q.push(root -> nxt[i]);
        }
    }

    while(!Q.empty()) {
        trie_node *node = Q.front();
        Q.pop();

        for(int i = 0; i < 26; i++) {
            if(node -> nxt[i] != NULL) {
                trie_node *next_node = node -> nxt[i], *pi;
                Q.push(next_node);
                
                for(pi = node -> pi; pi != root && pi -> nxt[i] == NULL; pi = pi -> pi);
                if(pi -> nxt[i] != NULL) {
                    pi = pi -> nxt[i];
                }
                
                next_node -> pi = pi;
                next_node -> mask |= pi -> mask;
            }
        }
    }
}

bool check_string(trie_node *root, string &X, vector <int> &len) {
    trie_node *curr = root;
    
    bool dp[X.size() + 1];
    memset(dp, false, sizeof(dp));

    dp[0] = true;
    for(int i = 0; i < X.size(); i++) {
        for(; curr != root && curr -> nxt[X[i] - 'a'] == NULL; curr = curr -> pi);
        if(curr -> nxt[X[i] - 'a'] != NULL) {
            curr = curr -> nxt[X[i] - 'a'];
        }
        
        for(int bit = 0; bit < len.size(); bit++) {
            if((curr -> mask & (1 << bit)) != 0) {
                dp[i + 1] = dp[i + 1] || dp[i + 1 - len[bit]];
            }
        }
    }

    return dp[X.size()];
}

string check(string (*F)(string), string B, vector<string>A) {
    size_t max_len = 0;
    for(auto &it : A) {
        if(max_len < it.size()) {
            max_len = it.size();
        }
    }

    trie_node *root = new trie_node;
    vector <int> len;
    for(string curr = B; curr.size() <= max_len; curr = F(curr)) {
        insert_trie(root, curr, len.size());
        len.push_back(curr.size());
    }
    
    compute_pi(root);

    string ret = "";
    for(auto &it : A) {
        if(check_string(root, it, len)) {
            ret.push_back('1');
        }
        else {
            ret.push_back('0');
        }
    }
    return ret;
}
