// @check-accepted: examples back dp1 dp2 mat-mul1 mat-mul2 mat-mul3
// insert brief description of the solution here

#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

const int MAXM = 2000;
const ll MOD = 1e9 + 7;

ll N, M, L, R, K;

int v[MAXM + 5], res[MAXM + 5];

struct mat {
    vector <vector <int>> a;
    int M;

    mat(int _m) {
        M = _m;
        a.resize(M, vector <int>(M));
        for(int i = 0;i < M;i++)
            for(int j = 0;j < M;j++)
                a[i][j] = 0;
    }

    void I() {
        for(int i = 0;i < M;i++)
            a[i][i] = 1;
    }

    void A(int *modcnt) {
        for(int i = 0;i < M;i++) {
            for(int j = 0;j < M;j++)
                a[i][j] = modcnt[(j + M - i) % M];
        }
    }

    void operator *= (const mat b) {
        //c0
        for(int i = 0;i < M;i++) 
            v[i] = b.a[i][0];
        //mul
        for (int i = 0;i < M;i++) {
            res[i] = 0;
            for (int j = 0;j < M;j++)
                res[i] = (res[i] + 1LL * this-> a[i][j] * v[j]) % MOD;
        }
        //expand
        for(int i = 0;i < M;i++) {
            for(int j = 0;j < M;j++)
                this->a[i][j] = res[(i - j + M) % M];
        }
    }
};

int main() {
    cin >> N >> M >> L >> R >> K;

    int modcnt[M];
    ll first = (L-1)/M+1, last = R/M;
    for (int i = 0;i < M;i++) {
        modcnt[i] = last - first;
        modcnt[i] += (M*last+i <= R) + (M*first-M+i >= L);
    }

    mat res(M), A(M);
    res.I(), A.A(modcnt);
    while (N > 0) {
        if (N & 1) res *= A;
        A *= A;
        N >>= 1;
    }
    cout << res.a[0][K] << endl;

    return 0;
}
